JSB.newAddon = function(mainPath){
  JSB.require('MdxDictController');
  var newAddonClass = JSB.defineClass('MdxDictAddon : JSExtension', /*Instance members*/{
    //Window initialize
    sceneWillConnect: function() {
        self.appInstance = Application.sharedInstance();
        self.addonController = MdxDictController.new();
        self.addonController.mainPath = mainPath;
        self.prevText = '';
        self.prevRect = '{{0, 0}, {10, 10}}';
        self.prevArrow = 1;
    },
    //Window disconnect
    sceneDidDisconnect: function() {
    },
    //Window resign active
    sceneWillResignActive: function() {
    },
    //Window become active
    sceneDidBecomeActive: function() {
    },
    notebookWillOpen: function(notebookid) {
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnSelection:','PopupMenuOnSelection');
      NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onClosePopupMenuOnSelection:','ClosePopupMenuOnSelection');
      //NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnNote:','PopupMenuOnNote');
      //NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onClosePopupMenuOnNote:','ClosePopupMenuOnNote');
      NSTimer.scheduledTimerWithTimeInterval(0.2, false, function() {
        if (self.appInstance.studyController(self.window).studyMode < 3 && NSUserDefaults.standardUserDefaults().objectForKey('MNAddon_MdxDict_On')) {// Not support in card deck mode
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.view.hidden = true;
          self.appInstance.studyController(self.window).refreshAddonCommands();
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function() { 
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      });
    },
    notebookWillClose: function(notebookid) {
      self.addonController.view.removeFromSuperview();
      NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnSelection');
      NSNotificationCenter.defaultCenter().removeObserverName(self,'ClosePopupMenuOnSelection');
      //NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnNote');
      //NSNotificationCenter.defaultCenter().removeObserverName(self,'ClosePopupMenuOnNote');
    },
    documentDidOpen: function(docmd5) {
    },
    documentWillClose: function(docmd5) {
    },
    controllerWillLayoutSubviews: function(controller) {
      if(controller == self.appInstance.studyController(self.window)){
          self.layoutAddonController();
      }
    },
    queryAddonCommandStatus: function() {
      if(self.appInstance.studyController(self.window).studyMode < 3)
        return {image:'MdxDict.png',object:self,selector:'toggleAddon:',checked:(self.addonController.view.window?true:false)};
      return null;
    },
    // Selecting text on pdf or epub
    onPopupMenuOnSelection: function(sender) {
      if(!self.appInstance.checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.addonController.view.window)return;
      if(self.viewTimer){self.viewTimer.invalidate();}
      var text = sender.userInfo.documentController.selectionText;
      if(text && text.length){
        self.addonController.lookup(text);
        self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
        self.addonController.view.hidden = false;
        self.prevText = text;
      }
    },
    // no response to clicking note
    onPopupMenuOnNote: function(sender) {
      /* TODO: Get current selected note.
      if(!self.appInstance.checkNotifySenderInWindow(sender,self.window))return;//Don't process message from other window
      if(!self.addonController.view.window)return;
      if(self.viewTimer){self.viewTimer.invalidate();}
      var text = sender.userInfo.note.allNoteText();
      if(text && text.length){
        self.addonController.lookup(text);
        self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
        self.addonController.view.hidden = false;
        self.prevText = text;
      }*/
    },
    onClosePopupMenuOnSelection: function(sender) {
      if (!sender.userInfo.documentController.selectionText) {
        self.addonController.view.hidden = true;
      } else {
        self.hideViewIfTextChanged(1);
      }
    },
    // no response to clicking note
    onClosePopupMenuOnNote: function(sender) {
      /* TODO: Get current selected note.
      if (!sender.userInfo.note.allNoteText()) {
        self.addonController.view.hidden = true;
      } else {
        self.hideViewIfTextChanged(0);
      }*/
    },
    toggleAddon: function(sender) {
      if (self.addonController.view.window) {
        NSUserDefaults.standardUserDefaults().setObjectForKey(false, 'MNAddon_MdxDict_On');
        self.addonController.view.removeFromSuperview();
        NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().removeObserverName(self,'ClosePopupMenuOnSelection');
        //NSNotificationCenter.defaultCenter().removeObserverName(self,'PopupMenuOnNote');
        //NSNotificationCenter.defaultCenter().removeObserverName(self,'ClosePopupMenuOnNote');
      } else {
        NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
        self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);        
        self.addonController.view.hidden = true;
        NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnSelection:','PopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onClosePopupMenuOnSelection:','ClosePopupMenuOnSelection');
        //NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onPopupMenuOnNote:','PopupMenuOnNote');
        //NSNotificationCenter.defaultCenter().addObserverSelectorName(self,'onClosePopupMenuOnNote:','ClosePopupMenuOnNote');
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function(){ 
          self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
        });
      }
      self.appInstance.studyController(self.window).refreshAddonCommands();
    },
  }, /*Class members*/{
    addonDidConnect: function() {
    },
    addonWillDisconnect: function() {
    },
    applicationWillEnterForeground: function() {
    },
    applicationDidEnterBackground: function() {
    },
    applicationDidReceiveLocalNotification: function(notify) {
    },
  });
  newAddonClass.prototype.hideViewIfTextChanged = function(textType) {
    // textType indicates text comes from selectionText (1) or noteText (0)
    this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.1, true, () => {
      var currText = this.appInstance.studyController(this.window).readerController.currentDocumentController.selectionText; // or current note text (TODO)
      if (!currText || currText !== this.prevText) {
        this.addonController.view.hidden = true;
        this.viewTimer.invalidate();
      }
    });
  };

  newAddonClass.prototype.layoutAddonController = function(rect, arrow) {
    this.prevRect = rect || this.prevRect;
    this.prevArrow = arrow || this.prevArrow;
    var x, y
        w = (this.appInstance.osType !== 1) ? 620 : 365, // this.addonController.view.frame.width
        h = 650, // this.addonController.view.frame.height
        fontSize = 15,
        margin = 10,
        padding = 20,
        frame = this.appInstance.studyController(this.window).view.bounds,
        W = frame.width,
        H = frame.height,
        rectArr = this.prevRect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
        X = Number(rectArr[0]),
        Y = Number(rectArr[1]),
        studyMode = this.appInstance.studyController(this.window).studyMode,
        // contextMenuWidth does not affect iPad display, note that contextMenuWidth of notes is about 620px
        contextMenuWidth = studyMode === 0 ? 225 : 435,
        contextMenuHeight = 35,
        textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w/2 - margin <= 0) {
        x = margin;
      } else if (X + w/2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w/2;
      }
    } else {
      if (X - contextMenuWidth/2 - margin <= 0) {
        x = margin + contextMenuWidth/2 - w/2;
      } else if (X + contextMenuWidth/2 + margin >= W) {
        x = W - margin - contextMenuWidth/2 - w/2;
      } else {
        x = X - w/2;
      }
    }
    
    // this.addonController.view.frame.[y, height]
    if (this.prevArrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
          lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
          lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h; 
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }

    this.addonController.view.frame = {x: x, y: y, width: w, height: h};
  };

  return newAddonClass;
};